// ** Windows CE Loader **

#include <windows.h>

#define GX_FULLSCREEN		0x01		// for OpenDisplay()
#define GX_NORMALKEYS		0x02
#define GX_LANDSCAPEKEYS	0x03

struct GXKeyList {
	short vkUp;				// key for up
	POINT ptUp;				// x,y position of key/button.  Not on screen but in screen coordinates.
	short vkDown;
	POINT ptDown;
	short vkLeft;
	POINT ptLeft;
	short vkRight;
	POINT ptRight;
	short vkA;
	POINT ptA;
	short vkB;
	POINT ptB;
	short vkC;
	POINT ptC;
	short vkStart;
	POINT ptStart;
};

static struct GXKeyList _portrait_keys;
 
typedef int (*tGXVoidFunction)(void);
typedef struct GXKeyList (*tGXGetDefaultKeys)(int);
 
int disableHardwareKeyMapping() {
	HINSTANCE GAPI_handle;

	//GAPI_handle = LoadLibrary(TEXT("gx.dll"));
	return -1;
}
 
int main (int argc, char **argv)
{
	HINSTANCE GAPI_handle;

	tGXVoidFunction GAPIOpenInput;
	tGXVoidFunction GAPICloseInput;

	tGXGetDefaultKeys GAPIGetDefaultKeys;
	
	STARTUPINFO si;
    	PROCESS_INFORMATION pi;

    	ZeroMemory( &si, sizeof(si) );
    	si.cb = sizeof(si);
    	ZeroMemory( &pi, sizeof(pi) );

	char                 szExe[] = "cmd.exe";
	char		     CmdLine[] = "\\uae\\uae.exe -f uae.txt";

	int init_error = 0;

	GAPI_handle = LoadLibrary(TEXT("gx.dll"));
		
	if (!GAPI_handle){
		init_error = 1;
		printf("GAPI: no handle!\n");
	}
	
	GAPIOpenInput = (tGXVoidFunction)GetProcAddress(GAPI_handle, TEXT("?GXOpenInput@@YAHXZ"));
	if (!GAPIOpenInput){
		init_error = 1;
		printf("GAPI: no OpenInput!\n");	
	}
	
	GAPICloseInput = (tGXVoidFunction)GetProcAddress(GAPI_handle, TEXT("?GXCloseInput@@YAHXZ"));
	if (!GAPICloseInput){
		init_error = 1;
		printf("GAPI: no CloseInput!\n");	
	}

	GAPIGetDefaultKeys = (tGXGetDefaultKeys)GetProcAddress(GAPI_handle, TEXT("?GXGetDefaultKeys@@YA?AUGXKeyList@@H@Z"));
	if (!GAPIGetDefaultKeys){
		init_error = 1;
		printf("GAPI: no Defaultkeys!\n");	
	}
	
	if (init_error == 1){
		LPVOID lpMsgBuf;
		FormatMessage( 
    			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
    			FORMAT_MESSAGE_FROM_SYSTEM | 
    			FORMAT_MESSAGE_IGNORE_INSERTS,
    			NULL,
    			GetLastError(),
    			0, // Default language
    			(LPTSTR) &lpMsgBuf,
    			0,
    			NULL 
			);
		// Display the string.
		MessageBox( NULL, (LPCTSTR)lpMsgBuf, L"Error", MB_OK | MB_ICONINFORMATION );
		// Free the buffer.
		LocalFree( lpMsgBuf );		
		return 0;
	}
	
	GAPIOpenInput();
	
	_portrait_keys = GAPIGetDefaultKeys(GX_NORMALKEYS);

	real_main (argc, argv);
	// Start the child process. 
    	/* if( !CreateProcess(
    		TEXT("\\uae\\uae.exe"),		  // Module name
        	NULL,		  // Command line. 
        	NULL,             // Process handle not inheritable. 
        	NULL,             // Thread handle not inheritable. 
        	FALSE,            // Set handle inheritance to FALSE. 
        	0,                // No creation flags. 
        	NULL,             // Use parent's environment block. 
        	NULL,             // Use parent's starting directory. 
        	&si,              // Pointer to STARTUPINFO structure.
        	&pi )             // Pointer to PROCESS_INFORMATION structure.
    	) 
    	{
		LPVOID lpMsgBuf;
		FormatMessage( 
    			FORMAT_MESSAGE_ALLOCATE_BUFFER | 
    			FORMAT_MESSAGE_FROM_SYSTEM | 
    			FORMAT_MESSAGE_IGNORE_INSERTS,
    			NULL,
    			GetLastError(),
    			0, // Default language
    			(LPTSTR) &lpMsgBuf,
    			0,
    			NULL 
			);
		// Display the string.
		MessageBox( NULL, (LPCTSTR)lpMsgBuf, L"Error", MB_OK | MB_ICONINFORMATION );
		// Free the buffer.
		LocalFree( lpMsgBuf );
        	return;
    	}else{
    		printf( "Subprocess created!\n");
    	}

    	// Wait until child process exits.
    	WaitForSingleObject( pi.hProcess, INFINITE );
    	
    	printf( "Subprocess terminated!\n");

    	// Close process and thread handles. 
    	CloseHandle( pi.hProcess );
    	CloseHandle( pi.hThread );
        */
        
	GAPICloseInput();
	
	FreeLibrary(GAPI_handle);
    	
	return 0;
}

